/* Onderj Polacek - Hippo Games - GPL :-) 
 * 
 * opravky pro Linux: Bernard Lidicky
 * 
 * */
#include <stdlib.h>
#include <allegro.h>
#include <time.h>
#include <math.h>
#include <fstream.h>

#include "players.h"
#include "datafile.h"

//#define NOSOUND

BITMAP *pitch;
HBall mic;
HPlayer hraci[22];
DATAFILE *dat;
volatile int ticks=0;


#ifndef itoa

char* itoa(int i, char* , int )
{
	static char buff[60];
	snprintf(buff, 60, "%d", i);
	return buff;
}

#endif

void inc_ticks(void)     // timer, to nejhlavnejsi je ZDE
{
 ticks++;
}

END_OF_FUNCTION(inc_ticks);     // ???? - to potrebuje Allegro

int Draw(int dom,int host,int sel_pl= -1)
{
 int x= mic.GetX()-320;
 int y= mic.GetY()-240;
 int xp=0,yp=0;

 if (x<0) x= 0;
 if (y<0) y= 0;
 if (x>PITCH_X+2*PITCH_X_B-640) x= PITCH_X+2*PITCH_X_B-640;
 if (y>PITCH_Y+2*PITCH_Y_B-480) y= PITCH_Y+2*PITCH_Y_B-480;

 BITMAP *tmp= create_bitmap(SCREEN_W,SCREEN_H);
 blit(pitch,tmp,x,y,0,0,SCREEN_W,SCREEN_H);
 BITMAP* bmp= mic.GetNext();
 int pl= mic.GetPlayer();
 switch (hraci[pl].GetGO())
  {
   case SM_E : xp= 3; yp= -5; break;
   case SM_W : xp= -13; yp= -6; break;
   case SM_N : xp= -5; yp= -13; break;
   case SM_S : xp= -5; yp= 3; break;
   case SM_NE : xp= 1; yp= -12; break;
   case SM_SE : xp= 1; yp= 1; break;
   case SM_NW : xp= -11; yp= -11; break;
   case SM_SW : xp= -11; yp= 1; break;
  }

 masked_blit(bmp,tmp,0,0,mic.GetX()-x+xp+PITCH_X_B,mic.GetY()-y+yp+PITCH_Y_B,bmp->w,bmp->h);
 for (int i=0;i< 22;i++)
  {
   if (hraci[i].GetX()>x-PITCH_X_B && hraci[i].GetX()<x+640 && hraci[i].GetY()>y-PITCH_Y_B && hraci[i].GetY()<y+480)
    {
     bmp= hraci[i].GetBitmap();
     int w= bmp->w;
     int h= bmp->h;
     if (i==sel_pl) circle(tmp,hraci[i].GetX()-x+PITCH_X_B,hraci[i].GetY()-y+PITCH_Y_B,15,makecol(0xff,0xff,0));
     masked_blit(bmp,tmp,0,0,hraci[i].GetX()-x-w/2+PITCH_X_B,hraci[i].GetY()-y-h/2+PITCH_Y_B,w,h);
     char buff[10];
     snprintf(buff, 10, "%d", i);
     textout(tmp,font,buff,hraci[i].GetX()-x,hraci[i].GetY()-y+20,makecol(0xff,0,0));
    }
  }
 for (int i=0;i<40;i=i+2) line(tmp,540,i,640,i,makecol(250-i*6,250-i*6,250-i*6));
 textout(tmp,font,itoa(dom,NULL,10),570,10,makecol(0xff,0xff,0xff));
 textout(tmp,font,itoa(host,NULL,10),620,10,makecol(0xff,0xff,0xff));

 blit(tmp,screen,0,0,0,0,SCREEN_W,SCREEN_H);
 destroy_bitmap(tmp);
}

int Prihraj(int& sel_pl,int co) // vraci vzdalenost
{
 char able[22];
 int sx= hraci[sel_pl].GetX();
 int sy= hraci[sel_pl].GetY();
 int x,y;
 int START,END;

 if (co==0)
  { START= 0; END= 11; } else { START= 11; END= 22; }

 for (int i= START;i<END;i++)
  { if (i== sel_pl)
   { able[i]= FALSE;
    continue;
   }
   int alpha;
   x= hraci[i].GetX()-sx;
   y= hraci[i].GetY()-sy;
   alpha= int((180*(atan(double(y)/x)/M_PI)));
   if (alpha<0) alpha= 180+alpha;
   if (y<0) alpha= 180+alpha;
   switch (hraci[sel_pl].GetGO())
    {
     case SM_W : if (alpha> 157 && alpha< 203) able[i]= TRUE; else able[i]= FALSE; break;
     case SM_E : if (alpha> 327 || alpha< 23) able[i]= TRUE; else able[i]= FALSE; break;
     case SM_S : if (alpha> 67 && alpha< 113) able[i]= TRUE; else able[i]= FALSE; break;
     case SM_N : if (alpha> 247 && alpha< 293) able[i]= TRUE; else able[i]= FALSE; break;
     case SM_SW : if (alpha> 112 && alpha< 158) able[i]= TRUE; else able[i]= FALSE; break;
     case SM_NW : if (alpha> 202 && alpha< 248) able[i]= TRUE; else able[i]= FALSE; break;
     case SM_SE : if (alpha> 22 && alpha< 68) able[i]= TRUE; else able[i]= FALSE; break;
     case SM_NE : if (alpha> 292 && alpha< 338) able[i]= TRUE; else able[i]= FALSE; break;
    }
  }
 int len= 0,maxlen=0xffff;
 for (int i= START;i<END;i++)
  {
   if (able[i])
    {
     len= int(sqrt((hraci[i].GetX()-sx)*(hraci[i].GetX()-sx))+(hraci[i].GetY()-sy)*(hraci[i].GetY()-sy));
     if (len<maxlen)
      {
       maxlen= len;
       sel_pl= i;
      }
    }
  }
 return maxlen;
}

int is_in(int x1,int y1,int x2,int y2,int x,int y)
{
 if ((x1<=x+5 && x2>=x-5) && (y1<=y+5 && y2>=y-5)) return TRUE;
 return FALSE;
}

int u_mice(int sel_pl= -1)
{
 int mx1= mic.GetX();
 int my1= mic.GetY();
 int mx2= mic.GetX()+mic.GetW();
 int my2= mic.GetY()+mic.GetH();

 for (int i= 0;i<22;i++)
  {
   if (i== sel_pl) continue;
   int x1= hraci[i].GetX();
   int y1= hraci[i].GetY();
   int x2= hraci[i].GetX()+hraci[i].GetW();
   int y2= hraci[i].GetY()+hraci[i].GetH();

   if (is_in(x1,y1,x2,y2,mx1,my1) || is_in(x1,y1,x2,y2,mx1,my2) ||
     is_in(x1,y1,x2,y2,mx2,my1) || is_in(x1,y1,x2,y2,mx2,my2)) return i;
  }
 return -1;
}

long sqr(long i)
{
 return i*i;
}

int nejblizsi(int co,int sp= -1)
{
 int START,END,sel_pl;

 int sx= mic.GetX();
 int sy= mic.GetY();

 if (co==0)
  { START= 1; END= 11; } else { START= 11; END= 22; }
 int len,maxlen= int(sqrt(sqr(hraci[START].GetX()-sx)+sqr(hraci[START].GetY()-sy)));
 sel_pl= START;
 for (int i= START+1;i<END;i++)
  {
   if (i== sp) continue;
   len= int(sqrt(sqr(hraci[i].GetX()-sx)+sqr(hraci[i].GetY()-sy)));
   if (len<maxlen)
    {
     maxlen= len;
     sel_pl= i;
    }
  }
 return sel_pl;
}

void di_nekam(int i,int x,int y,int zak)
{
 if (hraci[i].GetX()-x>0)
  {
   if (hraci[i].GetY()-y>31) hraci[i].GO(SM_N,0,-zak-random()%2);
   else if (hraci[i].GetY()-y<32 && hraci[i].GetY()-y>15) hraci[i].GO(SM_NW,-zak-random()%2,-zak-random()%2);
   else if (hraci[i].GetY()-y<16 && hraci[i].GetY()-y>-15) hraci[i].GO(SM_W,-zak-random()%2,0);
   else if (hraci[i].GetY()-y<-16 && hraci[i].GetY()-y>-32) hraci[i].GO(SM_SW,-zak-random()%2,+zak+random()%2);
   else hraci[i].GO(SM_S,0,+zak+random()%2);
  }
 if (hraci[i].GetX()-x<0)
  {
   if (hraci[i].GetY()-y>31) hraci[i].GO(SM_N,0,-zak-random()%2);
   else if (hraci[i].GetY()-y<32 && hraci[i].GetY()-y>15) hraci[i].GO(SM_NE,+zak+random()%2,-zak-random()%2);
   else if (hraci[i].GetY()-y<16 && hraci[i].GetY()-y>-15) hraci[i].GO(SM_E,+zak+random()%2,0);
   else if (hraci[i].GetY()-y<-16 && hraci[i].GetY()-y>-32) hraci[i].GO(SM_SE,+zak+random()%2,+zak+random()%2);
   else hraci[i].GO(SM_S,0,+zak+random()%2);
  }

}

void Posun(int co,int x,int y)
{
 int px= hraci[co].GetX();
 int py= hraci[co].GetY();
 if (px<x && py<y) hraci[co].GO(SM_SE,random()%3+2,random()%3+2);
 else if (px>x && py<y) hraci[co].GO(SM_SW,-random()%3-2,random()%3+2);
 else if (px<x && py>y) hraci[co].GO(SM_NE,random()%3+2,-random()%3-2);
 else if (px>x && py>y) hraci[co].GO(SM_NW,-random()%3-2,-random()%3-2);
 else if (px<x) hraci[co].GO(SM_E,random()%3+2,0);
 else if (px>x) hraci[co].GO(SM_W,-random()%3-2,0);
 else if (py<y) hraci[co].GO(SM_S,0,random()%3+2);
 else if (py>y) hraci[co].GO(SM_N,0,-random()%3-2);
}

int vzdalenost(int p1,int p2)
{
 int len= int(sqrt(sqr(hraci[p1].GetX()-hraci[p2].GetX())+sqr(hraci[p1].GetY()-hraci[p2].GetY())));
 return len;
}

int vzdalenost(int p1,int x,int y)
{
 int len= int(sqrt(sqr(hraci[p1].GetX()-x)+sqr(hraci[p1].GetY()-y)));
 return len;
}

struct strela {
 int kam,y;
};

struct rozehravka {
 int x,y;
 int co;
};

void pozice_hracu(const char* fn)
{
 ifstream ifs(fn);
 int x,y;
 for (int i= 0;i<22;i++)
  {
   ifs >> x;
   hraci[i].SetX(x);
   ifs >> y;
   hraci[i].SetY(y);
  }
 ifs >> x;
 ifs >> y;
 mic.SetX(x); mic.SetY(y);
}

int Play()
{
 int sel_pl= 0;
 int drz_mice= 0;
 int obrany_pl=-1;
 int Domaci=0,Hoste=0;
 int doba;
 rozehravka zacatek;

 zacatek.co= ZAC_DOM;

for (;!key[KEY_ESC];)
 {
 strela strel;
 strel.kam= -1;

 for (int i= 0;i< 22;i++) hraci[i].SetDef();
 mic.Clear();
 clear_keybuf();
// zacatek.co= ROH_DOM;
// zacatek.x=640;
 doba= 0;
 switch (zacatek.co)
  {
   case ZAC_DOM : hraci[10].SetX(PITCH_X/2);
                  hraci[10].SetY(PITCH_Y/2-40);
                  hraci[9].SetX(PITCH_X/2);
                  hraci[9].SetY(PITCH_Y/2);
                  hraci[9].GO(SM_N,0,0);
                  mic.SetX(PITCH_X/2);
                  mic.SetY(PITCH_Y/2);
                  Draw(Domaci,Hoste,9);
                  mic.SetPlayer(-1);
                  for (;!key[KEY_S];); break;
   case ZAC_HOST: hraci[21].SetX(PITCH_X/2);
                  hraci[21].SetY(PITCH_Y/2-40);
                  hraci[20].SetX(PITCH_X/2);
                  hraci[20].SetY(PITCH_Y/2);
                  hraci[20].GO(SM_N,0,0);
                  mic.SetX(PITCH_X/2);
                  mic.SetY(PITCH_Y/2);
                  Draw(Domaci,Hoste);
                  mic.SetPlayer(-1);
                  for (ticks= 0;ticks<50;); break;
   case VYKOP_DOM : mic.SetPlayer(0);
                  mic.SetX(hraci[0].GetX());
                  mic.SetY(hraci[0].GetY());
                  Draw(Domaci,Hoste,0);
                  for (;!key[KEY_S];); break;
   case VYKOP_HOST : mic.SetPlayer(11);
                  mic.SetX(hraci[11].GetX());
                  mic.SetY(hraci[11].GetY());
                  Draw(Domaci,Hoste);
                  for (ticks= 0;ticks<50;); break;
   case ROH_DOM : if (zacatek.x< 320) { pozice_hracu("rohdom1.txt"); hraci[1].GO(SM_SW,0,0);}
                  else { pozice_hracu("rohdom2.txt"); hraci[4].GO(SM_NW,0,0);}
                  Draw(Domaci,Hoste);
                  for (;!key[KEY_S];); break;
   case ROH_HOST : if (zacatek.x< 320) { pozice_hracu("rohhost1.txt"); hraci[12].GO(SM_SE,0,0);}
                   else { pozice_hracu("rohhost2.txt"); hraci[15].GO(SM_NE,0,0);}
                   Draw(Domaci,Hoste);
                   for (ticks= 0;ticks<50;);
                   if (zacatek.x< 320) mic.GoTo(hraci[16].GetX(),hraci[16].GetY());
                   else mic.GoTo(hraci[21].GetX(),hraci[21].GetY());
                   mic.SetPlayer(-1); doba= 8; break;
   case OUT_DOM : { mic.SetX(zacatek.x); mic.SetY(zacatek.y);
                  int pom= 0;
                  if (zacatek.y== 0) pom= SM_S; else pom= SM_N;
                  hraci[5].GO(pom,0,0); hraci[5].SetXY(zacatek.x,zacatek.y);
                  Draw(Domaci,Hoste,5);
                  drz_mice= 0;
                  for (;!key[KEY_S];); } break;
   case OUT_HOST : { mic.SetX(zacatek.x); mic.SetY(zacatek.y);
                  int pom= 0;
                  if (zacatek.y== 0) pom= SM_S; else pom= SM_N;
                  hraci[16].GO(pom,0,0); hraci[16].SetXY(zacatek.x,zacatek.y);
                  Draw(Domaci,Hoste);
                  for (ticks= 0;ticks<50;);
                  if (zacatek.x< 320) mic.GoTo(hraci[20].GetX(),hraci[20].GetY());
                  else mic.GoTo(hraci[21].GetX(),hraci[21].GetY());
                  drz_mice= 1;
                  mic.SetPlayer(-1); doba= 8;} break;
  }
 ticks= 1;
 for (;!key[KEY_ESC];)
  {
   if (ticks>0)
    {
    if (sel_pl!=obrany_pl)
    {
     // ovladani_hrace
     if (key[KEY_RIGHT] && key[KEY_UP]) hraci[sel_pl].GO(SM_NE,random()%2+4,-random()%2-4);
     else if (key[KEY_RIGHT] && key[KEY_DOWN]) hraci[sel_pl].GO(SM_SE,random()%2+4,random()%2+4);
     else if (key[KEY_LEFT] && key[KEY_UP]) hraci[sel_pl].GO(SM_NW,-random()%2-4,-random()%2-4);
     else if (key[KEY_LEFT] && key[KEY_DOWN]) hraci[sel_pl].GO(SM_SW,-random()%2-4,random()%2+4);
     else if (key[KEY_LEFT]) hraci[sel_pl].GO(SM_W,-random()%2-4,0);
     else if (key[KEY_UP]) hraci[sel_pl].GO(SM_N,0,-random()%2-4);
     else if (key[KEY_RIGHT]) hraci[sel_pl].GO(SM_E,random()%2+4,0);
     else if (key[KEY_DOWN]) hraci[sel_pl].GO(SM_S,0,random()%2+4);
     if (key[KEY_D] && mic.GetPlayer()>=0)
       if (mic.GetPlayer()<11 && drz_mice== 0)
        {
         strel.kam= drz_mice;
         if (key[KEY_UP]) strel.y= 245-7+random()%20;
         else if (key[KEY_DOWN]) strel.y= 395-13+random()%7;
         else strel.y= 320-10+random()%20;
         int vzy= (SHOT_PWR*(mic.GetY()-strel.y))/abs(1280-mic.GetX());
         vzy= hraci[mic.GetPlayer()].GetY()-vzy;
         mic.GoTo(SHOT_PWR+mic.GetX(),vzy,TRUE);
         doba= 3;
#ifndef NOSOUND
         if (hraci[mic.GetPlayer()].GetX()>800 && hraci[mic.GetPlayer()].GetX()<1080)
            play_sample((SAMPLE*)dat[SMP_STRELA].dat,1000,128,1000,FALSE);
#endif
         mic.SetPlayer(-1);
        }
       else if (mic.GetPlayer()>=11 && drz_mice== 1)
        {
          int um= u_mice(mic.GetPlayer());
          if (um<11 && um!= obrany_pl) if (random()%2==0)
           {
            obrany_pl= mic.GetPlayer();
            drz_mice= 0;
            mic.SetPlayer(um);
            doba= 20;
            clear_keybuf();
            readkey();
           } else
           {
            obrany_pl= um;
#ifndef NOSOUND
            if (random()%3==0) play_sample((SAMPLE*)dat[SMP_KLICKA].dat,1000,128,1000,FALSE);
#endif
            doba= 20;
           }
          key[KEY_D]= FALSE;
        }
    }
     if (key[KEY_S])
      {
       if (mic.GetPlayer()>=0 && mic.GetPlayer()<11)
        {
         if (Prihraj(sel_pl,0)!= 0xffff) mic.GoTo(hraci[sel_pl].GetX(),hraci[sel_pl].GetY());
          else
           switch (hraci[sel_pl].GetGO())
           {
            case SM_W : mic.GoTo(hraci[sel_pl].GetX()-200,hraci[sel_pl].GetY()); break;
            case SM_E : mic.GoTo(hraci[sel_pl].GetX()+200,hraci[sel_pl].GetY()); break;
            case SM_S : mic.GoTo(hraci[sel_pl].GetX(),hraci[sel_pl].GetY()+200); break;
            case SM_N : mic.GoTo(hraci[sel_pl].GetX(),hraci[sel_pl].GetY()-200); break;
            case SM_SW : mic.GoTo(hraci[sel_pl].GetX()-200,hraci[sel_pl].GetY()+200); break;
            case SM_NW : mic.GoTo(hraci[sel_pl].GetX()-200,hraci[sel_pl].GetY()-200); break;
            case SM_SE : mic.GoTo(hraci[sel_pl].GetX()+200,hraci[sel_pl].GetY()+200); break;
            case SM_NE : mic.GoTo(hraci[sel_pl].GetX()+200,hraci[sel_pl].GetY()-200); break;
           }
         doba= 8;
         mic.SetPlayer(-1);
        } else if (mic.GetPlayer()>=11) sel_pl= nejblizsi(0,mic.GetPlayer());
          else sel_pl= nejblizsi(0);
      }


     if (mic.GetPlayer()>=0)
      {
       int pl= mic.GetPlayer();
       mic.SetX(hraci[pl].GetX());
       mic.SetY(hraci[pl].GetY());
      } else
      { if (doba== 0)
         {
          mic.SetPlayer(u_mice());
          if (mic.GetPlayer()>=0)
           { mic.GoTo(-1,-1); strel.kam= -1;}
         }
      }
     if (mic.GetPlayer()>=0 && mic.GetPlayer()<11)
      { drz_mice= 0;
        sel_pl= mic.GetPlayer();
      }
     if (mic.GetPlayer()>=11 && mic.GetPlayer()<22) drz_mice= 1;

     // "logika" ostanich hracu

     int sp;
     if (drz_mice==0 || mic.GetPlayer()== -1) sp= nejblizsi(1); else sp= nejblizsi(0);
     if (sp!= obrany_pl && sp!= sel_pl) di_nekam(sp,mic.GetX(),mic.GetY(),3);

     if (mic.GetPlayer()>=0 && mic.GetPlayer()<11)
      { int um= u_mice(mic.GetPlayer());
       if (um>=11 && obrany_pl!= um)
        {
         if (key[KEY_A])
          {
           if (random()%2==0)
            { drz_mice= 1;
              obrany_pl= mic.GetPlayer();
              mic.SetPlayer(um);
              doba= 20;
            } else
            { obrany_pl= sp;
#ifndef NOSOUND
              if (random()%3==0) play_sample((SAMPLE*)dat[SMP_KLICKA].dat,1000,128,1000,FALSE);
#endif
              doba= 20;
            }
          } else
           {drz_mice= 1;
            obrany_pl= mic.GetPlayer();
            mic.SetPlayer(um);
            doba= 20;
           }
        }
      }

     int poc_hr=0;
     for (int j= 0;j<2;j++)
      for (int i= j*11;i<j*11+11;i++)
       if (i!= sel_pl)
        {
         if (i== sp) continue;
         if (i== obrany_pl) continue;
         if (mic.GetPlayer()>=11 && i== mic.GetPlayer()) continue;
         // brankari
         if (strel.kam== j)
          {
           if (i== 0)
            {if (hraci[11].GetY()<mic.GetY()) hraci[11].GO(SM_W,0,5);
             else if (hraci[11].GetY()>mic.GetY()) hraci[11].GO(SM_W,0,-5);
            } else if (i== 11)
            {if (hraci[0].GetY()<mic.GetY()) hraci[0].GO(SM_E,0,5);
             else if (hraci[0].GetY()>mic.GetY()) hraci[0].GO(SM_E,0,-5);
            }
          } else if (i== 0 || i== 11)
          { if (sp!= 0) Posun(0,hraci[0].GetDefX(),hraci[0].GetDefY());
            if (sp!= 11) Posun(11,hraci[11].GetDefX(),hraci[11].GetDefY());
            if (mic.GetPlayer()<11 && mic.GetPlayer()>=0 && mic.GetX()>1080 && mic.GetY()>300 && mic.GetY()<340)
               hraci[11].GO(SM_W,-5,0);
            if (mic.GetPlayer()>=11 && mic.GetX()<200 && mic.GetY()>300 && mic.GetY()<340)
               hraci[11].GO(SM_E,5,0);
            continue;
          }

         if (vzdalenost(i,mic.GetX(),mic.GetY())<AKTIVNI_OBLAST && poc_hr<2 && drz_mice!= j)
            { di_nekam(i,mic.GetX(),mic.GetY(),3); continue; }

         if (hraci[i].GetY()< hraci[i].GetDefY()) hraci[i].GO(SM_S,random()%2,random()%3+2);
            else if (hraci[i].GetY()> hraci[i].GetDefY())
             if (random()%2==0) { hraci[i].GO(SM_S,random()%2,-random()%3-2); continue;}
         if (drz_mice==0 && j== 0)
          {
           if (mic.GetX()>860) if (hraci[i].GetDefX()+600>hraci[i].GetX()) hraci[i].GO(SM_E,random()%3+2,0);
           if (mic.GetX()>430) if (hraci[i].GetDefX()+350>hraci[i].GetX()) hraci[i].GO(SM_E,random()%2+3,0);
           continue;
          }
         if (drz_mice==1 && j== 0)
          {
           if (hraci[i].GetDefX()-50<hraci[i].GetX()) hraci[i].GO(SM_W,-3-random()%2,0);
           continue;
          }
         if (drz_mice==1 && j== 1)
          {
           if (mic.GetX()<430) if (hraci[i].GetDefX()-350<hraci[i].GetX()) hraci[i].GO(SM_W,-random()%3-2,0);
           if (mic.GetX()<860) if (hraci[i].GetDefX()-600<hraci[i].GetX()) hraci[i].GO(SM_W,-random()%2-3,0);
           continue;
          }
         if (drz_mice==0 && j== 1)
          {
           if (hraci[i].GetDefX()+50>hraci[i].GetX()) hraci[i].GO(SM_E,3+random()%2,0);
           continue;
          }
        }

     // logika "spielmachra"

     if (mic.GetPlayer()>=11)
      {
       if (mic.GetPlayer()==11) // brankar
        {
         int pom= 11;
         switch (random()%3)
         {
          case 0 : hraci[11].GO(SM_W,0,0); break;
          case 1 : hraci[11].GO(SM_NW,0,0); break;
          case 2 : hraci[11].GO(SM_SW,0,0); break;
         }
         if (Prihraj(pom,1)!= 0xffff) mic.GoTo(hraci[pom].GetX(),hraci[pom].GetY());
           else mic.GoTo(320,random()%640);
         doba= 8;
         mic.SetPlayer(-1);
        } else
        {
         int np= nejblizsi(0);
         Posun(mic.GetPlayer(),0,320);
         if (vzdalenost(np,0,320)<250) // strela
          {
           strel.kam= drz_mice;
           int key_d= random()%3;
           if (key_d==0) strel.y= 245-7+random()%20;
           else if (key_d== 1) strel.y= 395-13+random()%7;
           else strel.y= 320-10+random()%20;
           int vzy= (SHOT_PWR*(mic.GetY()-strel.y))/abs(mic.GetX());
           vzy= hraci[mic.GetPlayer()].GetY()-vzy;
           mic.GoTo(-SHOT_PWR+mic.GetX(),vzy,TRUE);
           doba= 3;
#ifndef NOSOUND
           if (hraci[mic.GetPlayer()].GetX()<480 && hraci[mic.GetPlayer()].GetX()>200)
              play_sample((SAMPLE*)dat[SMP_STRELA].dat,1000,128,1000,FALSE);
#endif
           mic.SetPlayer(-1);
          }
         else if (vzdalenost(np,mic.GetPlayer())<20) // nahravka
          {
           np= mic.GetPlayer();
           int ok= FALSE;
           for (int i= 0;i< 8;i++)
            {
             switch (i)
             {
              case 0 : hraci[np].GO(SM_W,0,0); break;
              case 1 : hraci[np].GO(SM_NW,0,0); break;
              case 2 : hraci[np].GO(SM_SW,0,0); break;
              case 3 : hraci[np].GO(SM_N,0,0); break;
              case 4 : hraci[np].GO(SM_S,0,0); break;
              case 5 : hraci[np].GO(SM_SE,0,0); break;
              case 6 : hraci[np].GO(SM_NE,0,0); break;
              case 7 : hraci[np].GO(SM_E,0,0); break;
             }
             int pom= np;
             if (Prihraj(np,1)!= 0xffff)
              {
               if (np== 11) {np= pom; continue;}
               ok= TRUE;
               break;
              }
            }
           if (ok)
            {
             mic.GoTo(hraci[np].GetX(),hraci[np].GetY());
             mic.SetPlayer(-1);
             doba= 8;
            }
          }
        }
      }


//     if (mic.GetPlayer()>=0 && mic.GetPlayer()<11 && mic.GetX()>1100 && mic.GetY()>200 && mic.GetY()<440)
//      if (random()%35==0) play_sample((SAMPLE*)dat[SMP_SANCE].dat,1000,128,1000,FALSE);

     // outy,rohy,goly

     if (mic.GetX()>1280)
      {
       if (mic.GetY()>240 && mic.GetY()<400)
        {
         Hoste++;
#ifndef NOSOUND
         if (Hoste+Domaci==1) play_sample((SAMPLE*)dat[SMP_1ST_GOAL].dat,1000,128,1000,FALSE);
         else play_sample((SAMPLE*)dat[SMP_GOAL].dat,1000,128,1000,FALSE);
#endif
         zacatek.co= ZAC_HOST;
        } else if (drz_mice== 0) { zacatek.co= VYKOP_HOST; }
          else { zacatek.co= ROH_DOM; zacatek.x= mic.GetY();
#ifndef NOSOUND
             if (random()%2==0) play_sample((SAMPLE*)dat[SMP_ROH1].dat,256,128,1000,FALSE);
             else play_sample((SAMPLE*)dat[SMP_ROH2].dat,256,128,1000,FALSE);
#endif
             }
        break;
      }

      if (mic.GetX()<0)
      {
       if (mic.GetY()>240 && mic.GetY()<400)
        {
         Domaci++;
#ifndef NOSOUND
         if (Hoste+Domaci==1) play_sample((SAMPLE*)dat[SMP_1ST_GOAL].dat,1000,128,1000,FALSE);
         else play_sample((SAMPLE*)dat[SMP_GOAL].dat,256,128,1000,FALSE);
#endif
         zacatek.co= ZAC_DOM;
        } else if (drz_mice== 1) { zacatek.co= VYKOP_DOM; }
          else
           { zacatek.co= ROH_HOST; zacatek.x= mic.GetY();
#ifndef NOSOUND
             if (random()%2==0) play_sample((SAMPLE*)dat[SMP_ROH1].dat,256,128,1000,FALSE);
             else play_sample((SAMPLE*)dat[SMP_ROH2].dat,256,128,1000,FALSE);
#endif
             }
        break;
      }

      if (mic.GetY()<0)
       {
        if (drz_mice==0)
         { zacatek.x= mic.GetX(); zacatek.y= 0; zacatek.co= OUT_HOST;}
        else if (drz_mice==1)
         { zacatek.x= mic.GetX(); zacatek.y= 0; zacatek.co= OUT_DOM;}
#ifndef NOSOUND
        play_sample((SAMPLE*)dat[SMP_OUT].dat,256,128,1000,FALSE);
#endif
        break;
       }

      if (mic.GetY()>640)
       {
        if (drz_mice==0)
         { zacatek.x= mic.GetX(); zacatek.y= 640; zacatek.co= OUT_HOST;}
        else if (drz_mice==1)
         { zacatek.x= mic.GetX(); zacatek.y= 640; zacatek.co= OUT_DOM;}
#ifndef NOSOUND
        play_sample((SAMPLE*)dat[SMP_OUT].dat,256,128,1000,FALSE);
#endif
        break;
       }

//     if (mic.GetPlayer()>=11)

//     Draw(Domaci,Hoste);
     Draw(Domaci,Hoste,sel_pl);
     ticks= 0;
     if (doba>0) doba--;
     else obrany_pl= -1;
    }
  }
 }
 return 0;
}

int Init()
{
 RGB pal[256];

 allegro_init();
 install_keyboard();
 install_timer();
 install_mouse();
 install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,NULL);
 set_color_depth(16);
#ifndef NOSOUND
 dat= load_datafile("fotbal.dat");
 if (dat== NULL) return FALSE;
#endif
 LOCK_VARIABLE(ticks);
 LOCK_FUNCTION(inc_ticks);
 install_int(inc_ticks,35);
 pitch= load_bitmap("pitch.pcx",pal);
 set_gfx_mode(GFX_AUTODETECT_WINDOWED,640,480,0,0);
// set_gfx_mode(GFX_AUTODETECT,640,480,0,0);

 mic.Load();
 for (int i=0;i< 11;i++) hraci[i].Load(0);
 for (int i=11;i< 22;i++) hraci[i].Load(1);

 ifstream ifs("players.txt");
 for (int i= 0;i<22;i++)
  {
   int x,y;
   ifs >> x;
   ifs >> y;
   if (ifs.bad() || ifs.fail()) break;
   hraci[i].SetDefXY(x,y);
  }

 srandom(time(NULL));
 text_mode(-1);
 return TRUE;
}

void Exit()
{
 set_gfx_mode(GFX_TEXT,80,25,0,0);
 remove_int(inc_ticks);
 allegro_exit();
 exit(0);
}

int main()
{
 if (!Init()) return 1;
#ifndef NOSOUND
 play_sample((SAMPLE*)dat[SMP_UVOD].dat,1000,128,1000,FALSE);
 #endif
 Play();
 Exit();
 return 0;
}
