#ifndef __PLAYERS_H__
#define __PLAYERS_H__

#include <allegro.h>

#define BALL_MAX_FRAMES 2
#define PLAYER_MAX_FRAMES 1
#define SHOT_PWR 550
#define AKTIVNI_OBLAST 100

#define PITCH_X 1280
#define PITCH_Y 640
#define PITCH_X_B 40
#define PITCH_Y_B 40

enum smery {
SM_E= 0,
SM_NE= 1,
SM_N= 2,
SM_NW= 3,
SM_W= 4,
SM_SW= 5,
SM_S= 6,
SM_SE= 7,
};

enum standardni_situace {
ZAC_DOM= 0,
ZAC_HOST= 1,
VYKOP_DOM= 2,
VYKOP_HOST= 3,
ROH_DOM= 4,
ROH_HOST= 5,
OUT_DOM= 6,
OUT_HOST= 7,
};

class HBall {
private:
 double x,y,xplus,yplus;
 int frame,player,sh;
 BITMAP *bmp[BALL_MAX_FRAMES];
public:

 HBall() { xplus= 0; yplus=0; player=0; frame=0;}
 int GetX() {return int(x);}
 int GetY() {return int(y);}
 int GetPlayer() {return player;}
 int GetW() {return bmp[frame]->w;}
 int GetH() {return bmp[frame]->h;}
 int GetX(int _x) {x= _x;}
 int GetY(int _y) {y= _y;}
 void SetPlayer(int _p) {player= _p;}
 void Clear() { xplus=0; yplus=0;}
 BITMAP* GetNext();
 void GoTo(int,int,int shot= FALSE);
 void SetX(int _x) {x= double(_x);}
 void SetY(int _y) {y= double(_y);}
 int Load();
};

class HPlayer {
private:

 struct Frames {
  BITMAP *frm[PLAYER_MAX_FRAMES];
  int cnt;
 };

 Frames bmp[8];
 int x,y,go,defx,defy;

public:

 HPlayer() { go= SM_E; bmp[go].cnt= 0;}
 int GetGO() {return go;}
 int GetX() {return x;}
 int GetY() {return y;}
 int GetW() {return bmp[0].frm[0]->w;}
 int GetH() {return bmp[0].frm[0]->w;}
 int GetDefX() {return defx;}
 int GetDefY() {return defy;}
 void GO(int sm,int xpl,int ypl);
 BITMAP* GetBitmap();
 void SetX(int _x) {x= _x;}
 void SetY(int _y) {y= _y;}
 void SetXY(int _x,int _y) {x= _x;y= _y;}
 void SetDefX(int _x) {defx= _x;}
 void SetDefY(int _y) {defy= _y;}
 void SetDefXY(int _x,int _y) {defx= _x; defy= _y;}
 void SetDef() {x= defx; y= defy;}
 int Load(int);
};

#endif
